' Large Font on VGA
' This program does NOT use double buffering as it takes too much memory. So some flickering is visable
'
CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  x_tiles = 16
  y_tiles = 12

  Background = 0
  Red = 1
  Black = 2
  White = 3

VAR
  long  bitmap[3072+64] ' Must be aligned on 32 byte boundary
  long  colors[64]
  word  screen[x_tiles * y_tiles]

  long bitmapAddr
  byte numStr[5]
  


OBJ
  vga   : "vga"
  gr    : "graphics"

PUB start | i, waittime 

  StartVGA

  gr.textmode(4,4,6,5)
  gr.colorwidth(White,4)
  gr.text(0,75,string("CO2 Level"))

  gr.textmode(2,2,6,5)
  gr.colorwidth(White,2)
  gr.text(-80,-70,string("AVERAGE"))


  colors[0] := $FC_00_C0_30 ' Green background

  waittime := cnt
  i := 99

  repeat
    waitcnt(waittime+=clkfreq)

    i += 1
    if i > 9999
      i := 100

    num2str(i)
    'Draw box to erase old value
    gr.colorwidth(Background,14)
    gr.box(-40,-100,160,61)

    ' Draw new value
    gr.textmode(6,6,6,5)
    gr.colorwidth(Black, 6)
    gr.text(40, -68, @numStr)


    waitcnt(cnt+clkfreq / 100) ' Wait for gr.text to finish using numstr variable

    num2str(i)
    'Draw box to erase old value
    gr.colorwidth(Background,14)
    gr.box(-120,-30,240,81)

    'Draw new value
    gr.colorwidth(Red,8)
    gr.textmode(9,9,6,5)
    gr.text(0,10,@numStr)


PUB num2str(value) | given ' For numbers from 100 to 9999
  given := value
  if value < 1000
    value *= 10
    
  numStr[0] := value / 1000  + "0"
  value //= 1000
  numStr[1] := value / 100 + "0"
  value //= 100
  numStr[2] := value / 10 + "0"
  value //= 10
  numStr[3] := value + "0"
  numStr[4] := 0

  if given < 1000
    numStr[3] := 0



PUB StartVGA | i, dx, dy
  bitmapAddr := (@bitmap + $3F) & $FFFF_FFC0 ' Bitmap address must start on a 32 byte boundary 

  'start vga
  vga_videobase := @screen
  vga_colorbase := @colors
  vga.start(@vgaparams)

  'init colors
  repeat i from 0 to 63
    colors[i] := $FC_00_C0_30 ' Green background
    
  
  'init tile screen
  repeat dx from 0 to vga_hc - 1
    repeat dy from 0 to vga_vc - 1
      screen[dy * vga_hc + dx] := bitmapAddr >> 6 + dy + dx * vga_vc '+ ((dy & $3F) << 10)

  'start and setup graphics
  gr.start
  gr.setup(16, 12, 128, 96, bitmapAddr)


DAT

vgaparams               long    0               'status
                        long    1               'enable
                        long    %010_111        'pins
                        long    %0011           'mode
vga_videobase           long    0               'videobase
vga_colorbase           long    0               'colorbase
vga_hc                  long    x_tiles         'hc
vga_vc                  long    y_tiles         'vc
                        long    2               'hx        //RJA increased from 1X to 2X
                        long    2               'vx        //RJA increased from 1X to 2X 
                        long    0               'ho
                        long    0               'vo
                        long    512             'hd
                        long    16              'hf
                        long    96              'hs
                        long    48              'hb
                        long    380+16          'vd         //RJA added 16
                        long    11              'vf
                        long    2               'vs
                        long    31+16           'vb       //RJA subtracted 16
                        long    20_000_000      'rate